;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

              #include <P16F628A.INC>
              LIST        p=16F628A     
              __CONFIG    H'3F10'           ; 
                                               
              errorlevel  -302              ;     302  

Sec           equ         0020h             ;  
Sec1          equ         0021h             ;
Sec2          equ         0022h             ;
scetbit       equ         0024h             ;   -   
perem         equ         0025h             ;  /   spi, i2c                
temp          equ         0026h             ; 

perem_1       equ         0027h             ;  - .
result        equ         0028h             ;  - .

dat_ind       equ         0029h             ;      spi
adr_ind       equ         002Ah             ;      spi

second        equ         002Bh             ;     
minut         equ         002Ch             ;     
hour          equ         002Dh             ;     

adr_i2c       equ         002Eh             ;     i2c
tmp_i2c       equ         002Fh
slave_adr     equ         0030h
data_i2c      equ         0031h


flag          equ         007Fh             ; 
              
#DEFINE       int         PORTB,0           ;  INT/SQW DS3231
#DEFINE       sda         PORTB,1           ; SDA   DS3231
#DEFINE       scl         PORTB,2           ; SCL   DS3231
#DEFINE       sda_io      TRISB,1           ;  SDA
#DEFINE       scl_io      TRISB,2           ;  SCL

#DEFINE       datai       PORTB,5           ;    MAX7219
#DEFINE       cs          PORTB,6           ;   MAX7219
#DEFINE       clk         PORTB,7           ;   MAX7219

#DEFINE       led         PORTB,4           ;  i2c
#DEFINE       led_sec     PORTB,3           ;    1

#DEFINE       regim       PORTA,2           ;  -   
#DEFINE       nast        PORTA,3           ;  -     
#DEFINE       ust         PORTA,4           ;  -   

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

              org         0000h             ;     0000h
              goto        Start             ;   Start
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
                                             
Start         movlw       b'00000000'       ;     A     
              movwf       PORTA             ;
              movlw       b'01000000'       ;     B     
              movwf       PORTB             ; 
              
              movlw       b'00000111'       ; 
              movwf       CMCON             ;

              bsf         STATUS,RP0        ; 1-     
              movlw       b'00000111'       ;  \  B      
              movwf       TRISB             ;RB0-RB2 -  ,   
 
              movlw       b'11111111'       ;  \  A   
              movwf       TRISA             ;                         
              bcf         STATUS,RP0        ; 0-  
                     
              clrf        flag              ;   
                           
              call        init_lcd          ;    (MAX7219)
              call        viv_not           ;     "  ------ "
              
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
              
              movlw       b'11010000'       ;  (DS3231)
              movwf       slave_adr
                                            ; 4-    /  i2c
                                            ;   1- ,   
              movlw       data_i2c          ;   /  i2c
              movwf       FSR               ;
              movlw       b'10000000'       ;    1- 
              movwf       INDF              ;
              incf        FSR,F             ;
              movlw       b'10000000'       ;    1- 
              movwf       INDF              ;
              incf        FSR,F             ;
              movlw       b'10000000'       ;    1- 
              movwf       INDF              ;
              incf        FSR,F             ;
              movlw       b'10000000'       ;   /  1- 
              movwf       INDF              ;
                 
              movlw       .4                ; 4-   i2c
              movwf       tmp_i2c           ;
              movlw       0x07              ;    1- 
              movwf       adr_i2c           ;
              call        write_i2c         ;     i2c
              call        err_prov          ;   / I2C   

              movlw       .1                ; 1-   i2c
              movwf       tmp_i2c           ;
              movlw       0x0E              ;   Control 
              movwf       adr_i2c           ;
              movlw       data_i2c          ;   /  i2c
              movwf       FSR               ;
              movlw       b'00000101'       ;  ,    INT/SQW 
              movwf       INDF              ;   ,     INT/SQW 1,
                                            ; INT/SQW      ,
                                            ;   1- 
              call        write_i2c         ;     i2c
              call        err_prov          ;   / I2C     

met_2         movlw       .1                ; 1-   i2c
              movwf       tmp_i2c           ;
              movlw       0x0F              ;   Status
              movwf       adr_i2c           ;
              movlw       data_i2c          ;   /  i2c
              movwf       FSR               ;
              movlw       b'00000000'       ;  OSF,      EN32kHz,
              movwf       INDF              ;    A2F, A1F 
              call        write_i2c         ;     i2c
              call        err_prov          ;   / I2C         

met_1         btfsc       int               ;   
              goto        met_3             ;
              bsf         led_sec           ;    
              goto        met_4             ;
met_3         bcf         led_sec           ;    

              btfsc       nast              ;   
              goto        met_5             ;
              call        nast_time         ;   
              goto        met_2             ;

met_5         btfsc       regim             ;   
              goto        met_1             ;
met_6         call        paus_knp          ;
              btfss       regim             ;
              goto        met_6             ;

              btfss       flag,2            ;    
              goto        met_7             ;
              bcf         flag,2            ;  ,   
              goto        met_1             ;
met_7         bsf         flag,2            ;  ,     
              goto        met_1             ;

met_4         movlw       .1                ; 1-   i2c
              movwf       tmp_i2c           ;
              movlw       0x11              ;     
              movwf       adr_i2c           ;
              call        read_i2c          ;    I2C
              call        err_prov          ;   / I2C
              
              movf        INDF,W            ;     temp
              movwf       temp        

rd_time       movlw       .3                ; 3-   i2c
              movwf       tmp_i2c           ;
              movlw       0x00              ;    
              movwf       adr_i2c           ;
              call        read_i2c          ;    I2C
              call        err_prov          ;   / I2C

              btfsc       flag,2            ;   
              goto        met_8             ;
              call        vivod             ;       
              goto        met_2             ;
met_8         call        vivod_temp        ;                           
              goto        met_2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

vivod         movlw       data_i2c          ;   /  i2c
              movwf       FSR               ;
              movlw       0x01              ;    1- 
              movwf       adr_ind           ;
              movlw       b'00001111'       ;
              andwf       INDF,W            ;
              movwf       dat_ind           ;
              call        send              ;
              
              movlw       0x02              ;    2- 
              movwf       adr_ind           ;
              swapf       INDF,F            ;
              movlw       b'00001111'       ;
              andwf       INDF,W            ;
              movwf       dat_ind           ;
              call        send              ;

              incf        FSR,F             ;   
              movlw       0x03              ;    3- 
              movwf       adr_ind           ;
              movlw       b'00001111'       ;
              andwf       INDF,W            ;
              movwf       dat_ind           ;
              bsf         dat_ind,7         ;     
              call        send              ;

              movlw       0x04              ;    4- 
              movwf       adr_ind           ;
              swapf       INDF,F            ;
              movlw       b'00001111'       ;
              andwf       INDF,W            ;
              movwf       dat_ind           ;
              call        send              ;

              incf        FSR,F             ;   
              movlw       0x05              ;    5- 
              movwf       adr_ind           ;
              movlw       b'00001111'       ;
              andwf       INDF,W            ;
              movwf       dat_ind           ;
              bsf         dat_ind,7         ;     
              call        send              ;

              movlw       0x06              ;    6- 
              movwf       adr_ind           ;
              swapf       INDF,F            ;
              movlw       b'00001111'       ;
              andwf       INDF,W            ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x07              ; 7- 
              movwf       adr_ind           ;
              movlw       0x0F              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x08              ; 8- 
              movwf       adr_ind           ;
              movlw       0x0F              ;
              movwf       dat_ind           ;
              call        send              ;
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

vivod_temp    movlw       data_i2c          ;   /  i2c
              movwf       FSR               ;
              incf        FSR,F             ;   
              movlw       0x01              ;    1- 
              movwf       adr_ind           ;
              movlw       b'00001111'       ;
              andwf       INDF,W            ;
              movwf       dat_ind           ;
              call        send              ;
              
              movlw       0x02              ;    2- 
              movwf       adr_ind           ;
              swapf       INDF,F            ;
              movlw       b'00001111'       ;
              andwf       INDF,W            ;
              movwf       dat_ind           ;
              call        send              ;

              incf        FSR,F             ;   
              movlw       0x03              ;    3- 
              movwf       adr_ind           ;
              movlw       b'00001111'       ;
              andwf       INDF,W            ;
              movwf       dat_ind           ;
              btfss       flag,0            ;    
              goto        viv_1             ;
              bcf         dat_ind,7         ;
              bcf         flag,0            ;
              goto        viv_2             ;
viv_1         bsf         dat_ind,7         ;
              bsf         flag,0            ;
viv_2         call        send              ;

              movlw       0x04              ;    4- 
              movwf       adr_ind           ;
              swapf       INDF,F            ;
              movlw       b'00001111'       ;
              andwf       INDF,W            ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x05              ; 5- 
              movwf       adr_ind           ;
              movlw       0x0F              ;
              movwf       dat_ind           ;
              call        send              ;

              bcf         flag,1            ;   
              btfss       temp,7            ;  
              goto        viv_3             ;
              comf        temp,F            ;
              incf        temp,F            ;
              bsf         flag,1            ;   
viv_3         movf        temp,W            ;
              call        bin2bcd           ;   
                                            ;  -

              movlw       b'00001111'       ;   
              andwf       result,W          ;
              movwf       dat_ind           ;
              movlw       0x06              ;
              movwf       adr_ind           ;
              call        send              ;

              swapf       result,F          ;   
              movlw       b'00001111'       ;
              andwf       result,W          ;
              movwf       dat_ind           ;
              movlw       0x07              ;
              movwf       adr_ind           ;
              call        send              ;

              btfsc       flag,1            ;   
              goto        viv_4             ;
              movlw       0x08              ; 8- 
              movwf       adr_ind           ;
              movlw       0x0F              ;
              movwf       dat_ind           ;
              call        send              ;
              return
 
viv_4         movlw       0x08              ;    8- 
              movwf       adr_ind           ;
              movlw       0x0A              ;
              movwf       dat_ind           ;
              call        send              ;
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        
nast_time     call        paus_knp          ;    
              btfss       nast              ;
              goto        nast_time         ;
              call        viv_not           ;     "  ------ "

              clrf        hour              ;    
              clrf        minut             ;
              clrf        second            ;

nst_a1        movf        hour,W            ;
              call        bin2bcd           ;

              movlw       b'00001111'       ;   
              andwf       result,W          ;
              movwf       dat_ind           ;
              movlw       0x05              ;
              movwf       adr_ind           ;
              bsf         dat_ind,7         ;
              call        send              ;

              swapf       result,F          ;   
              movlw       b'00001111'       ;
              andwf       result,W          ;
              movwf       dat_ind           ;
              movlw       0x06              ;
              movwf       adr_ind           ;
              call        send              ;

nst_a3        btfsc       ust               ;  
              goto        nst_a2            ;
              call        paus_ust          ;  
              incf        hour,F            ;
              movlw       .24               ;
              xorwf       hour,W            ;
              btfsc       STATUS,Z          ;
              clrf        hour              ;
              goto        nst_a1            ;

nst_a2        btfsc       nast              ;  
              goto        nst_a3            ; 
nst_a4        call        paus_knp          ;
              btfss       nast              ;
              goto        nst_a4            ;
              
nst_b1        movf        minut,W           ;
              call        bin2bcd           ;

              movlw       b'00001111'       ;   
              andwf       result,W          ;
              movwf       dat_ind           ;
              movlw       0x03              ;
              movwf       adr_ind           ;
              bsf         dat_ind,7         ;
              call        send              ;

              swapf       result,F          ;   
              movlw       b'00001111'       ;
              andwf       result,W          ;
              movwf       dat_ind           ;
              movlw       0x04              ;
              movwf       adr_ind           ;
              call        send              ;

nst_b3        btfsc       ust               ;  
              goto        nst_b2            ;
              call        paus_ust          ;  
              incf        minut,F           ;
              movlw       .60               ;
              xorwf       minut,W           ;
              btfsc       STATUS,Z          ;
              clrf        minut             ;
              goto        nst_b1            ;

nst_b2        btfsc       nast              ;  
              goto        nst_b3            ; 
nst_b4        call        paus_knp          ;
              btfss       nast              ;
              goto        nst_b4            ;
             
nst_c1        movf        second,W          ;
              call        bin2bcd           ;

              movlw       b'00001111'       ;   
              andwf       result,W          ;
              movwf       dat_ind           ;
              movlw       0x01              ;
              movwf       adr_ind           ;
              call        send              ;

              swapf       result,F          ;   
              movlw       b'00001111'       ;
              andwf       result,W          ;
              movwf       dat_ind           ;
              movlw       0x02              ;
              movwf       adr_ind           ;
              call        send              ;

nst_c3        btfsc       ust               ;  
              goto        nst_c2            ;
              call        paus_ust          ;  
              incf        second,F          ;
              movlw       .60               ;
              xorwf       second,W          ;
              btfsc       STATUS,Z          ;
              clrf        second            ;
              goto        nst_c1            ;

nst_c2        btfsc       nast              ;  
              goto        nst_c3            ; 
nst_c4        call        paus_knp          ;
              btfss       nast              ;
              goto        nst_c4            ;

              movlw       data_i2c          ;   /  i2c
              movwf       FSR               ;  , ,          
              movf        second,W          ; -
              call        bin2bcd           ;
              movf        result,W          ;
              movwf       INDF              ;
              incf        FSR,F             ;
              movf        minut,W           ;
              call        bin2bcd           ;
              movf        result,W          ;
              movwf       INDF              ;
              incf        FSR,F             ;
              movf        hour,W            ;
              call        bin2bcd           ;
              movf        result,W          ;
              movwf       INDF              ;
              
                                            ;    
              movlw       .3                ; 3-   i2c
              movwf       tmp_i2c           ;
              movlw       0x00              ;     
              movwf       adr_i2c           ;
              call        write_i2c         ;     i2c
              call        err_prov          ;   / I2C 
              return  


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
              
err_prov      btfss       flag,6            ;    I2C
              return                        ; :    
err_1         bsf         led               ;:   led
              goto        err_1             ;   err_1:  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     1-6 ,  7,8 
        
viv_not       movlw       0x08              ; 8- 
              movwf       adr_ind           ;
              movlw       0x0F              ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x07              ; 7- 
              movwf       adr_ind           ;
              movlw       0x0F              ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x06              ;   6- 
              movwf       adr_ind           ;
              movlw       0x0A              ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x05              ;   5- 
              movwf       adr_ind           ;
              movlw       0x0A              ;
              movwf       dat_ind           ;
              call        send              ;            
              movlw       0x04              ;   4- 
              movwf       adr_ind           ;
              movlw       0x0A              ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x03              ;   3-  
              movwf       adr_ind           ;
              movlw       0x0A              ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x02              ;   2- 
              movwf       adr_ind           ;
              movlw       0x0A              ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x01              ;   1- 
              movwf       adr_ind           ;
              movlw       0x0A              ;
              movwf       dat_ind           ;
              call        send              ;
              return                        ;  


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  (MAX7219)  

init_lcd      call        pauslcd           ;   2 
              movlw       0x0F              ;  
              movwf       adr_ind           ;
              movlw       0x00              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x0C              ; 
              movwf       adr_ind           ;
              movlw       0x01              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x0A              ; 15/32
              movwf       adr_ind           ;
              movlw       0x07              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x09              ; BCD Code B   
              movwf       adr_ind           ;
              movlw       0xFF              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x0B              ; 8 
              movwf       adr_ind           ;
              movlw       0x07              ;
              movwf       dat_ind           ;
              call        send              ;
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  2-    (MAX7219)     SPI

send          bcf         cs                ;    CS
              movlw      .8                 ;    adr_ind
              movwf      scetbit            ;
povtor        bcf        clk                ;
              btfsc      adr_ind,7          ;
              bsf        datai              ;
              btfss      adr_ind,7          ;
              bcf        datai              ;
              bsf        clk                ;
              rlf        adr_ind,F          ;
              decfsz     scetbit,F          ;
              goto       povtor             ;
             
              movlw      .8                 ;    dat_ind
              movwf      scetbit            ;
povtr1        bcf        clk                ;
              btfsc      dat_ind,7          ;
              bsf        datai              ;
              btfss      dat_ind,7          ;
              bcf        datai              ;
              bsf        clk                ;
              rlf        dat_ind,F          ;
              decfsz     scetbit,F          ;
              goto       povtr1             ;
              bcf        clk                ;
              bsf        cs                 ;  1    CS                 
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     -
;   result

bin2bcd       movwf       perem_1           ;     
                                            ;    10 -  
d_10          clrf        result
              movlw       .10   
              bcf         STATUS,C
d_10_cikl     subwf       perem_1,F         ;     10
              btfss       STATUS,C
              goto        dd_ed             ;  ( ),
                                            ;    
              incf        result,F          ;   1  
              goto        d_10_cikl
dd_ed         addwf       perem_1,F         ;  10,  

              movlw       .4
              movwf       scetbit
              swapf       perem_1,F
dd1           rlf         perem_1,F
              rlf         result,F
              decfsz      scetbit,F
              goto        dd1
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; /   I2C

write_i2c     bsf         flag,4            ;  
              goto        i2c_1             ;   i2c_1
read_i2c      bcf         flag,4            ;  ( )
              bcf         flag,5            ;   
i2c_1         bcf         flag,6            ;   I2C
              call        starti2c          ;  ""  I2C
            
              bcf         slave_adr,0       ;  
              movf        slave_adr,W       ;  
              call        peredi2c          ; 
              btfsc       flag,6            ;  
              goto        err_i2c           ;:   err_i2c

              movf        adr_i2c,W         ;   DS3231
              call        peredi2c          ;   
              btfsc       flag,6            ;  
              goto        err_i2c           ;:   err_i2c
          
              movlw       data_i2c       
              movwf       FSR
              decf        FSR,F

              btfss       flag,4            ;  / I2C
              goto        rd_i2c            ;   rd_i2c ()

i2c_2         incf        FSR,F
              movf        INDF,W            ;   
              call        peredi2c          ;   I2C
              btfsc       flag,6            ;  
              goto        err_i2c           ;:   err_i2c

              decfsz      tmp_i2c,F
              goto        i2c_2
              call        stopi2c 
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

rd_i2c        call        starti2c          ;  ( )
              bsf         slave_adr,0       ;  
              movf        slave_adr,W       ;  
              call        peredi2c          ; 
              btfsc       flag,6            ;  
              goto        err_i2c           ;:   err_i2c

rd_i2c_2      decfsz      tmp_i2c,F
              goto        rd_i2c_1
              bsf         flag,5
rd_i2c_1      incf        FSR,F
              call        priemi2c          ; 
            
              movwf       INDF
              movlw       .0
              xorwf       tmp_i2c,F
              btfss       STATUS,Z
              goto        rd_i2c_2
              call        stopi2c           ; 
              return

err_i2c       call        stopi2c           ;  ""  I2C 
              return                        ;        I2C

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

starti2c      call        scl_1              ;  scl
              call        pausi2c            ; I2C (5 )
              call        sda_0              ;  0  sda
              call        pausi2c            ; I2C (5 )
              call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
              return                         ;  

stopi2c       call        sda_0              ;  0  sda
              call        pausi2c            ; I2C (5 )
              call        scl_1              ;  scl
stpi2c_1      call        pausi2c            ; I2C (5 )
              btfss       scl                ;
              goto        stpi2c_1           ;
              call        sda_1              ;  sda
              call        pausi2c            ; I2C (5 )
              return                         ;  

sda_1         bsf         STATUS,RP0         ;  sda  
              bsf         sda_io             ;        
              bcf         STATUS,RP0         ;
              return                         ;  

sda_0         bcf         sda                ;  sda  
              bsf         STATUS,RP0         ;
              bcf         sda_io             ;
              bcf         STATUS,RP0         ;
              return                         ;  

scl_1         bsf         STATUS,RP0         ;  scl  
              bsf         scl_io             ;        
              bcf         STATUS,RP0         ;
              return                        ;  

scl_0         bcf         scl                ;  scl  
              bsf         STATUS,RP0         ;
              bcf         scl_io             ;
              bcf         STATUS,RP0         ;
              return                         ;  


peredi2c      movwf       perem              ;    i2c
              movlw       .8                 ;
              movwf       scetbit            ;
prd_i2c_1     btfsc       perem,7            ;
              call        sda_1              ;  sda
              btfss       perem,7            ;
              call        sda_0              ;  0  sda
              call        scl_1              ;  scl
prd_i2c_2     call        pausi2c            ; I2C (5 )
              btfss       scl                ;
              goto        prd_i2c_2          ;
              call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
              rlf         perem,F            ;
              decfsz      scetbit,F          ;
              goto        prd_i2c_1          ;
            
              call        sda_1              ;  sda
              call        scl_1              ;  scl
prd_i2c_3     call        pausi2c            ; I2C (5 )
              btfss       scl                ;
              goto        prd_i2c_3          ;

              movlw       .20                ;  100 
              movwf       scetbit            ;
prd_i2c_4     btfss       sda                ;	
              goto        prd_i2c_5          ;
              decfsz      scetbit,F          ; 
              goto        prd_i2c_4          ;
              bsf         flag,6             ; ,    
prd_i2c_5     call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
              return                         ;  


priemi2c      movlw       .8                 ;    i2c
              movwf       scetbit            ;
              call        sda_1              ;  sda
prm_i2c_1     rlf         perem,F            ;
              call        scl_1              ;  scl
prm_i2c_2     call        pausi2c            ; I2C (5 )
              btfss       scl                ;
              goto        prm_i2c_2          ;
              btfsc       sda                ;
              bsf         perem,0            ;
              btfss       sda                ;
              bcf         perem,0            ;
              call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
              decfsz      scetbit,F          ;
              goto        prm_i2c_1          ;
 
              btfss       flag,5             ;
              call        sda_0              ;  0  sda

              call        scl_1              ;  scl
prm_i2c_3     call        pausi2c            ; I2C (5 )
              btfss       scl                ;
              goto        prm_i2c_3          ;
              call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
              movf        perem,W            ;
              return                         ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;             

pausi2c       nop                            ;  I2C (5 )
              return                         ;  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                  


pauslcd       movlw       .4                ;  2 
              movwf       Sec1              ;
p_l2          movlw       .166              ;
              movwf       Sec               ;
p_l1          decfsz      Sec,F             ;
              goto        p_l1              ;
              decfsz      Sec1,F            ;
              goto        p_l2              ;
              return                        ;  

paus_knp      movlw       .20               ;  15 
              movwf       Sec1              ;
pa_l2         movlw       .255              ;
              movwf       Sec               ;
pa_l1         decfsz      Sec,F             ;
              goto        pa_l1             ;
              decfsz      Sec1,F            ;
              goto        pa_l2             ;
              return                        ;  

paus_ust      movlw       .255              ;  200 
              movwf       Sec1              ;
pb_l2         movlw       .255              ;
              movwf       Sec               ;
pb_l1         decfsz      Sec,F             ;
              goto        pb_l1             ;
              decfsz      Sec1,F            ;
              goto        pb_l2             ;
              return                        ;  

              end                           ;  
